All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
cpu_ram.hpp File Reference

Implementations for the OpenCL backend functionality. More...

`#include <cassert>`
`#include <vector>`
`#include "viennacl/forwards.h"`
`#include "viennacl/tools/shared_ptr.hpp"`

Go to the source code of this file.

## Classes

struct | viennacl::backend::cpu_ram::detail::array_deleter< U >
| Helper struct for deleting an pointer to an array. More...

## Namespaces

| viennacl
| Main namespace in ViennaCL. Holds all the basic types such as vector, matrix, etc. and defines operations upon them.
| viennacl::backend
| Namespace providing routines for handling the different memory domains.
| viennacl::backend::cpu_ram
| Provides implementations for handling memory buffers in CPU RAM.
| viennacl::backend::cpu_ram::detail
| Holds implementation details for handling memory buffers in CPU RAM. Not intended for direct use by library users.

## Typedefs

typedef viennacl::tools::shared_ptr < char > | viennacl::backend::cpu_ram::handle_type

## Functions

handle_type | viennacl::backend::cpu_ram::memory_create (vcl_size_t size_in_bytes, const void *host_ptr=NULL)
| Creates an array of the specified size in main RAM. If the second argument is provided, the buffer is initialized with data from that pointer. More...
void | viennacl::backend::cpu_ram::memory_copy (handle_type const &src_buffer, handle_type &dst_buffer, vcl_size_t src_offset, vcl_size_t dst_offset, vcl_size_t bytes_to_copy)
| Copies 'bytes_to_copy' bytes from address 'src_buffer + src_offset' to memory starting at address 'dst_buffer + dst_offset'. More...
void | viennacl::backend::cpu_ram::memory_write (handle_type &dst_buffer, vcl_size_t dst_offset, vcl_size_t bytes_to_copy, const void *ptr, bool)
| Writes data from main RAM identified by 'ptr' to the buffer identified by 'dst_buffer'. More...
void | viennacl::backend::cpu_ram::memory_read (handle_type const &src_buffer, vcl_size_t src_offset, vcl_size_t bytes_to_copy, void *ptr, bool)
| Reads data from a buffer back to main RAM. More...

## Detailed Description

Implementations for the OpenCL backend functionality.

Definition in file cpu_ram.hpp.